/*
 * BookView.java
 *
 * Created on August 9, 2008, 12:58 PM
 */
package com.smartitengineering.demo.selectionsuite.multivieweditor;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.adapter.BasicComponentFactory;
import com.jgoodies.binding.beans.PropertyConnector;
import com.jgoodies.binding.value.ValueHolder;
import com.jgoodies.binding.value.ValueModel;
import com.smartitengineering.demo.selectionsuite.api.book.BookNode;
import com.smartitengineering.demo.suiteselection.domain.book.Book;
import java.awt.Image;
import java.text.DecimalFormat;
import java.text.ParseException;
import javax.swing.Action;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.text.MaskFormatter;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.openide.awt.UndoRedo;
import org.netbeans.core.spi.multiview.MultiViewDescription;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.openide.util.HelpCtx;
import org.openide.util.Lookup;
import org.openide.util.lookup.Lookups;
import org.openide.windows.TopComponent;


/**
 *
 * @author  modhu7
 */
public class BookView extends JPanel implements MultiViewDescription, MultiViewElement{
    private PresentationModel<Book> presentationModel;
    private ValueModel nameValueModel;
    public ValueModel stockAmountValueModel;
    public JLabel tempLabel = new JLabel();
    public PropertyConnector propertyConnector1;
    
    /** Creates new form BookView */
    public BookView() {
        initComponents();                       
    }
    
    /*public BookView (BookNode node){
    this(node, 
    }*/
    
            
    public BookView(BookNode bookNode, PresentationModel presentationModel) { 
        this.presentationModel = presentationModel;       
        nameValueModel = presentationModel.getModel(Book.PROPERTYNAME_NAME);
        stockAmountValueModel = presentationModel.getModel(Book.PROPERTYNAME_STRING_STOCKAMOUNT);
        System.out.println(bookNode.getBookName());
        //stockAmountValueModel = new ValueHolder();
        //stockAmountValueModel.setValue("1234");
        
                 
        initComponents();
        
        bookName.setText(bookNode.getBookName());
        
        stockAmount.setText(bookNode.getStringStockAmount());                        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        nameLabel = new javax.swing.JLabel();
        bookName = BasicComponentFactory.createLabel(nameValueModel);
        stockAmountLabel = new javax.swing.JLabel();
        stockAmount = BasicComponentFactory.createLabel(stockAmountValueModel);

        nameLabel.setText(org.openide.util.NbBundle.getMessage(BookView.class, "BookView.nameLabel.text")); // NOI18N

        bookName.setText(org.openide.util.NbBundle.getMessage(BookView.class, "BookView.bookName.text")); // NOI18N
        bookName.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                bookNameComponentShown(evt);
            }
        });

        stockAmountLabel.setText(org.openide.util.NbBundle.getMessage(BookView.class, "BookView.stockAmountLabel.text")); // NOI18N

        stockAmount.setText(org.openide.util.NbBundle.getMessage(BookView.class, "BookView.stockAmount.text")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(62, 62, 62)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(stockAmountLabel)
                    .addComponent(nameLabel))
                .addGap(45, 45, 45)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(bookName)
                    .addComponent(stockAmount))
                .addContainerGap(113, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(36, 36, 36)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(nameLabel)
                    .addComponent(bookName))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(stockAmountLabel)
                    .addComponent(stockAmount))
                .addContainerGap(218, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

private void bookNameComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_bookNameComponentShown
     // TODO add your handling code here:
}//GEN-LAST:event_bookNameComponentShown

    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_NEVER;
    }

    public String getDisplayName() {
        return "View";
    }

    public Image getIcon() {
        return null;
    }

    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }

    public String preferredID() {
        return "BookView";
    }

    public MultiViewElement createElement() {
        return this;
    }

    public JComponent getVisualRepresentation() {
        return this;
    }

    public JComponent getToolbarRepresentation() {
        return new JPanel();
    }

    public Action[] getActions() {
        return null;
    }

    public Lookup getLookup() {
        Lookup lookup = Lookups.singleton(this);
        return lookup;
    }

    public void componentOpened() {
        
    }

    public void componentClosed() {
        
    }

    public void componentShowing() {
        
    }

    public void componentHidden() {
        
    }

    public void componentActivated() {
        
    }

    public void componentDeactivated() {
        
    }

    public UndoRedo getUndoRedo() {
        return null;
    }

    public void setMultiViewCallback(MultiViewElementCallback arg0) {
        
    }

    public CloseOperationState canCloseElement() {
        return CloseOperationState.STATE_OK;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel bookName;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JLabel stockAmount;
    private javax.swing.JLabel stockAmountLabel;
    // End of variables declaration//GEN-END:variables
}
